<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from cookbook.texi on 28 April 1999 -->

<TITLE>The SUIF COOKBOOK - Example 2</TITLE>
<link href="cookbook_4.html" rel=Next>
<link href="cookbook_2.html" rel=Previous>
<link href="cookbook_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="cookbook_1.html">first</A>, <A HREF="cookbook_2.html">previous</A>, <A HREF="cookbook_4.html">next</A>, <A HREF="cookbook_8.html">last</A> section, <A HREF="cookbook_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC9" HREF="cookbook_toc.html#TOC9">Example 2 - Print All Array Instructions</A></H1>

<P>
This pass will print all the array instructions of a program.

</P>


<H2><A NAME="SEC10" HREF="cookbook_toc.html#TOC10">prog2.cc</A></H2>

<PRE>
#include &#60;stdlib.h&#62;
#include &#60;suif1.h&#62;

void do_instr(instruction * instr)
{
    if(instr-&#62;format() == inf_array) 
        instr-&#62;print();

    for(int i=0; i&#60;instr-&#62;num_srcs(); i++) {
        operand op(instr-&#62;src_op(i));
        if(op.is_instr())
            do_instr(op.instr());
    }
}

void each_tree_node(tree_node * tn, void * x)
{
    if(tn-&#62;kind() == TREE_INSTR) {
        tree_instr * ti = (tree_instr *)tn;
        instruction * inst = ti-&#62;instr();
        do_instr(inst);
    }
}

void do_proc(tree_proc * tp)
{
    proc_sym * psym = tp-&#62;proc();
    printf("%s \n", psym-&#62;name());
    tp-&#62;map(each_tree_node, NULL);
}

main(int argc, char * argv[])
{
    start_suif(argc, argv);
    suif_proc_iter(argc, argv, do_proc);
}

</PRE>

<P>
<A NAME="IDX17"></A>
<A NAME="IDX18"></A>
<A NAME="IDX19"></A>
<A NAME="IDX20"></A>
<A NAME="IDX21"></A>
<A NAME="IDX22"></A>
<A NAME="IDX23"></A>
<A NAME="IDX24"></A>
<A NAME="IDX25"></A>
<A NAME="IDX26"></A>
<A NAME="IDX27"></A>
<A NAME="IDX28"></A>
<A NAME="IDX29"></A>
<A NAME="IDX30"></A>
<A NAME="IDX31"></A>
<A NAME="IDX32"></A>
<A NAME="IDX33"></A>
<A NAME="IDX34"></A>
<A NAME="IDX35"></A>

</P>
<P>
<A NAME="IDX36"></A>
<A NAME="IDX37"></A>
<A NAME="IDX38"></A>
<A NAME="IDX39"></A>
<A NAME="IDX40"></A>
<A NAME="IDX41"></A>

</P>


<H2><A NAME="SEC11" HREF="cookbook_toc.html#TOC11">Makefile</A></H2>

<PRE>
TARGET = prog2
LIBS =		-lsuif1
SRCS =		prog2.cc
OBJS =		prog2.o

all:		prog2
install-bin:	install-prog

include $(SUIFHOME)/Makefile.std
</PRE>



<H2><A NAME="SEC12" HREF="cookbook_toc.html#TOC12">Testing the pass</A></H2>
<P>
Let's use the following input file:

</P>


<H3><A NAME="SEC13" HREF="cookbook_toc.html#TOC13">input2.c</A></H3>

<PRE>
double A[10000];
double B[100][100];

test1(int IU, int JU, int KU)
{
    int i, j, k;
    for(i=0; i&#60;IU; i++) 
        for(j=0; j&#60;JU; j++) {
            for(k=8; k&#60;KU; k++) 
                A[k] = A[k-8];
            B[i][j] = B[i+1][j] + A[i];
        }
    for(i=0; i&#60;IU; i++) 
        for(j=0; j&#60;JU; j++) 
            B[i][j] = B[i][j] + B[i+1][j];
}

test2( int KU)
{
    int  k;

    for(k=8; k&#60;KU; k++) 
        A[k] = A[1] + A[k] + A[k-8];
}
</PRE>



<H3><A NAME="SEC14" HREF="cookbook_toc.html#TOC14">Test session</A></H3>

<PRE>
csh&#62; prog2 input2.spd
test1
  16: array t:g37 (p.32) e1+0, size(64), index(test1.k), bound(e2)
  17: e1: ldc t:g36 (p.32) &#60;.A,0&#62;
  18: e2: ldc t:g4 (i.32) 10000
  19: array t:g37 (p.32) e1+0, size(64), index(e2), bound(e3)
  20: e1: ldc t:g36 (p.32) &#60;.A,0&#62;
  21: e2: sub t:g17 (i.32) test1.k, e4
  22: e4: ldc t:g17 (i.32) 8
  23: e3: ldc t:g4 (i.32) 10000
  32: array t:g37 (p.32) e1+0, size(64), index(test1.i, test1.j), 
      bound(e2, e3)
  33: e1: ldc t:g38 (p.32) &#60;.B,0&#62;
  34: e2: ldc t:g4 (i.32) 100
  35: e3: ldc t:g4 (i.32) 100
  38: array t:g37 (p.32) e1+0, size(64), index(e2, test1.j), bound(e3, e4)
  39: e1: ldc t:g38 (p.32) &#60;.B,0&#62;
  40: e2: add t:g17 (i.32) test1.i, e5
  41: e5: ldc t:g17 (i.32) 1
  42: e3: ldc t:g4 (i.32) 100
  43: e4: ldc t:g4 (i.32) 100
  45: array t:g37 (p.32) e1+0, size(64), index(test1.i), bound(e2)
  46: e1: ldc t:g36 (p.32) &#60;.A,0&#62;
  47: e2: ldc t:g4 (i.32) 10000
  70: array t:g37 (p.32) e1+0, size(64), index(test1.i, test1.j), 
      bound(e2, e3)
  71: e1: ldc t:g38 (p.32) &#60;.B,0&#62;
  72: e2: ldc t:g4 (i.32) 100
  73: e3: ldc t:g4 (i.32) 100
  76: array t:g37 (p.32) e1+0, size(64), index(test1.i, test1.j), 
      bound(e2, e3)
  77: e1: ldc t:g38 (p.32) &#60;.B,0&#62;
  78: e2: ldc t:g4 (i.32) 100
  79: e3: ldc t:g4 (i.32) 100
  81: array t:g37 (p.32) e1+0, size(64), index(e2, test1.j), bound(e3, e4)
  82: e1: ldc t:g38 (p.32) &#60;.B,0&#62;
  83: e2: add t:g17 (i.32) test1.i, e5
  84: e5: ldc t:g17 (i.32) 1
  85: e3: ldc t:g4 (i.32) 100
  86: e4: ldc t:g4 (i.32) 100
test2
   8: array t:g37 (p.32) e1+0, size(64), index(test2.k), bound(e2)
   9: e1: ldc t:g36 (p.32) &#60;.A,0&#62;
  10: e2: ldc t:g4 (i.32) 10000
  14: array t:g37 (p.32) e1+0, size(64), index(e2), bound(e3)
  15: e1: ldc t:g36 (p.32) &#60;.A,0&#62;
  16: e2: ldc t:g17 (i.32) 1
  17: e3: ldc t:g4 (i.32) 10000
  19: array t:g37 (p.32) e1+0, size(64), index(test2.k), bound(e2)
  20: e1: ldc t:g36 (p.32) &#60;.A,0&#62;
  21: e2: ldc t:g4 (i.32) 10000
  23: array t:g37 (p.32) e1+0, size(64), index(e2), bound(e3)
  24: e1: ldc t:g36 (p.32) &#60;.A,0&#62;
  25: e2: sub t:g17 (i.32) test2.k, e4
  26: e4: ldc t:g17 (i.32) 8
  27: e3: ldc t:g4 (i.32) 10000
</PRE>

<P><HR><P>
<p>Go to the <A HREF="cookbook_1.html">first</A>, <A HREF="cookbook_2.html">previous</A>, <A HREF="cookbook_4.html">next</A>, <A HREF="cookbook_8.html">last</A> section, <A HREF="cookbook_toc.html">table of contents</A>.
</BODY>
</HTML>
